
.include "cpctelera.h.s"
.include "cpct_functions.h.s"
.include "man/entity_manager.h.s"
.include "sys/render_system.h.s"
.include "sys/physics_system.h.s"
.include "sys/generator_system.h.s"
.include "sys/collision_system.h.s"
.include "man/man_game.h.s"
.include "man/man_levels.h.s"
.area _DATA 
.area _CODE
;_x, _y, _w, _h, _vx, _vy, _color, _prevX, _prevY, _state
;;DefineEntity player, 3, 99, 2, 8, 0, 0, 0x0F, 0, 0,   #entity_player


_main::
   ;;call cpct_disableFirmware_asm
      call render_sys_init

   call print_Title
    _wait_to_start:
      call cpct_waitVSYNC_asm
      call wait_forInput
      cp #0
      jr z, _wait_to_start
      jr _continue

   _continue:  
      call game_init
      call render_Draw

loop:

      call cpct_waitVSYNC_asm
      call  physics_sys_update   
      call  physics_sys_update_Nave
      
      call  physics_sys_update_Enemigo

      
      call  physics_ship_keyboard
      call  generator_sys_update
      call  generator_sys_update_enemigos

      call cpct_waitVSYNC_asm

      call  render_sys_update
      call  render_sys_update_Enemigo
      call  render_sys_update_Nave
         
      call cpct_waitVSYNC_asm

      

      call  entity_man_getStarsArray_IX
      ld    hl, #entity_man_setStarsArray_IX
      call  entity_man_update 

      call  entity_man_getNaveArray_IX
      ld    hl, #entity_man_setNaveArray_IX
      call  entity_man_update

      call  entity_man_getEnemyArray_IX
      ld    hl, #entity_man_setEnemyArray_IX
      call  entity_man_update     


      call entity_man_check_lifes
      call man_update_levels
      call  sys_collision_check 
     ; .rept 10
     ;    ;halt
     ;    call cpct_waitVSYNC_asm
     ; .endm
      jr loop