
.globl entity_man_getStarsArray_IX
.globl entity_man_setStarsArray_IX
.globl entity_man_getNaveArray_IX
.globl entity_man_setNaveArray_IX
.globl entity_man_getEnemyArray_IX
.globl entity_man_setEnemyArray_IX
   
.globl entity_man_getNumEntities_A
.globl entity_man_getNumEntities_BC
.globl entity_man_getLastEntity_IX
.globl entity_man_getFreeSpace_A

.globl cpct_memset_asm 

.globl entity_man_create
.globl entity_man_destroy
.globl entity_man_init
.globl entity_man_set4destroy
.globl entity_man_set4destroy_IY
.globl entity_man_update
.globl entity_man_forAll
.globl entity_man_reset_entities
.globl entity_man_lose_a_life
.globl entity_man_reset_lifes
.globl entity_man_check_lifes



.macro DefineEntityAnnonimous _x, _y, _w, _h _vx, _vy, _sprite, _prevX, _prevY, _state
   .db _state
   .db _x
   .db _y
   .db _w
   .db _h
   .db _vx
   .db _vy
   .dw _sprite   
   .db _prevX
   .db _prevY
.endm  

.macro DefineEntity _name, _x, _y, _w, _h, _vx, _vy, _sprite, _prevX, _prevY, _state
	_name::
		DefineEntityAnnonimous _x, _y, _w, _h, _vx, _vy, _sprite, _prevX, _prevY, _state
.endm

.macro DefineEntityArray _name, _N
	_name::
		.rept _N
			DefineEntityAnnonimous 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
		.endm
      .dw 0x00
   _num_entities'_name::   .db 0
   _last_elem_ptr'_name::  .dw _name
   _max_entities'_name::   .dw _N

.endm 

e_state = 0
e_x = 1
e_y = 2
e_w = 3
e_h = 4
e_vx = 5
e_vy = 6
e_sprite_l = 7
e_sprite_h = 8

e_prevX = 9
e_prevY = 10
entity_size = 11    ; Tamaño maximo que tiene una entidad

entity_player = 0x01       ; Marcador para saber si una entidad es una estrella  0b00000001
entity_bullet = 0x02       ; Marcador para saber si una entidad es una bala      0b00000010
entity_enemy = 0x04        ; Marcador para saber si una entidad es un enemigo    0b00000100
entity_star = 0x08         ; Marcador para saber si una entidad es una estrella  0b10000010 & 0b10000000
entity_dead = 0x80         ; Marcador para saber si una entidad esta muerta
entity_invalid = 0x00      ; Marcador para saber si una entidad es invalida
game_normal = 0x00
game_dead = 0x01
