
.include "cpctelera.h.s"
.include "cpct_functions.h.s"
.include "man/entity_manager.h.s"
.include "man/man_game.h.s"
.include "sys/collision_system.h.s"
.include "sys/generator_system.h.s"
.include "man/man_levels.h.s"


nivel1: .asciz "NIVEL 1 COMPLETADO. PULSA Q PARA EL NIVEL 2"
nivel2: .asciz "NIVEL 2 COMPLETADO. PULSA Q PARA EL NIVEL 3"
nivel3: .asciz "NIVEL 3 COMPLETADO. PULSA Q PARA EL NIVEL 4"
nivel4: .asciz "NIVEL 4 COMPLETADO. VICTORIA"


enemies_left:
    .db #0x90


man_init_enemies_left::
    ld a, #0x90
    ld (enemies_left), a
    ret
man_decrease_enemies_left::
    ld a, (enemies_left)
    dec a
    ld (enemies_left), a
    ret

man_update_levels::
    
    ld a, (enemies_left)
    
    ;CADA 10 ENEMIGOS SE AVANZA DE NIVEL
    sub   #0x1D
    call z, level_4

    ld a, (enemies_left)
    sub #0x4F 
    call z, level_3

    ld a, (enemies_left)
    sub #0x6D 
    call z, level_2

    ld a, (enemies_left)
    sub #0x81 ; 
    call z, level_1
    ret


level_1::
    call clearScreen
    call print_level1
    _wait_to_start_1:
      call cpct_waitVSYNC_asm
      call wait_forInput
      cp #0
      jr z, _wait_to_start_1

 _continue_1:
        ld b, #2
        call set_current_level_B
        call man_decrease_enemies_left ; llamamos otra vez para que no entre de nuevo al bucle
        call clearScreen
        ;Iniciamos las entidades y el sistema de render
   
        call game_next_level
        ret

level_2::
    call clearScreen
    call print_level2
    _wait_to_start_2:
      call cpct_waitVSYNC_asm
      call wait_forInput
      cp #0
      jr z, _wait_to_start_2

 _continue_2:
        
        ld b, #3
      call set_current_level_B
        call man_decrease_enemies_left ; llamamos otra vez para que no entre de nuevo al bucle
        call clearScreen
        ;Iniciamos las entidades y el sistema de render

        call game_next_level
        ret

level_3::
    
    call clearScreen
    call print_level3
    _wait_to_start_3:
      call cpct_waitVSYNC_asm
      call wait_forInput
      cp #0
      jr z, _wait_to_start_3

 _continue_3:
        ld b, #4
      call set_current_level_B
        call man_decrease_enemies_left ; llamamos otra vez para que no entre de nuevo al bucle
        call clearScreen
        ;Iniciamos las entidades y el sistema de render

        call game_next_level
        ret
level_4::
        call clearScreen
        call print_level4
        _wait_to_start_4:
        call cpct_waitVSYNC_asm
        call wait_forInput
        cp #0
        jr z, _wait_to_start_4

 _continue_4:
        ld b, #1
        call set_current_level_B
        call man_decrease_enemies_left ; llamamos otra vez para que no entre de nuevo al bucle
        call clearScreen
        ;Iniciamos las entidades y el sistema de render
    
        call man_init_enemies_left
        call jugarOtraVez
        ;call game_init
        ret
    ret


print_level1::

    ld   	 de, #0xC000  			; \
        ld    	 b, #50				; |	
        ld    	 c, #25				; | Calculamos la posicion en pantalla
        call cpct_getScreenPtr_asm    	; /


        ex de, hl
        ;ld hl, #_nave_sp
        ld hl, #_nivel1_sp
        ld b, #80 ;alto
        ld c, #40;ancho


        ;(2B HL) sprite	Source Sprite Pointer (array with pixel data)
        ;(2B DE) memory	Destination video memory pointer
        ;(1B C ) width	Sprite Width in bytes [1-63] (Beware, not in pixels!)
        ;(1B B ) height	Sprite Height in bytes (>0)        

        call cpct_drawSprite_asm
        ret

print_level2::
    ld   	 de, #0xC000  			; \
        ld    	 b, #50				; |	
        ld    	 c, #25				; | Calculamos la posicion en pantalla
        call cpct_getScreenPtr_asm    	; /


        ex de, hl
        ;ld hl, #_nave_sp
        ld hl, #_nivel2_sp
        ld b, #80 ;alto
        ld c, #40;ancho


        ;(2B HL) sprite	Source Sprite Pointer (array with pixel data)
        ;(2B DE) memory	Destination video memory pointer
        ;(1B C ) width	Sprite Width in bytes [1-63] (Beware, not in pixels!)
        ;(1B B ) height	Sprite Height in bytes (>0)        

        call cpct_drawSprite_asm
        ret

print_level3::
    ld   	 de, #0xC000  			; \
        ld    	 b, #50				; |	
        ld    	 c, #25				; | Calculamos la posicion en pantalla
        call cpct_getScreenPtr_asm    	; /


        ex de, hl
        ;ld hl, #_nave_sp
        ld hl, #_nivel3_sp
        ld b, #80 ;alto
        ld c, #40;ancho


        ;(2B HL) sprite	Source Sprite Pointer (array with pixel data)
        ;(2B DE) memory	Destination video memory pointer
        ;(1B C ) width	Sprite Width in bytes [1-63] (Beware, not in pixels!)
        ;(1B B ) height	Sprite Height in bytes (>0)        

        call cpct_drawSprite_asm
        ret

print_level4::
    ld   	 de, #0xC000  			; \
        ld    	 b, #50				; |	
        ld    	 c, #25				; | Calculamos la posicion en pantalla
        call cpct_getScreenPtr_asm    	; /


        ex de, hl
        ;ld hl, #_nave_sp
        ld hl, #_nivel4_sp
        ld b, #80 ;alto
        ld c, #40;ancho


        ;(2B HL) sprite	Source Sprite Pointer (array with pixel data)
        ;(2B DE) memory	Destination video memory pointer
        ;(1B C ) width	Sprite Width in bytes [1-63] (Beware, not in pixels!)
        ;(1B B ) height	Sprite Height in bytes (>0)        

        call cpct_drawSprite_asm
        ret


